(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "X Window System Mathematica Notebook Front End Version 2.2";

	X11StandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, fontName, "times";
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, fontName, "times";
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, fontName, "times";
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, fontName, "times";
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, fontName, "times";
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, fontName, "times";
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, fontName, "times";
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold,  12, fontName, "courier";
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, fontName, "courier";
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w396, h403,  12, fontName, "courier";
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535,  10, fontName, "times";
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  12, fontName, "times";
	fontset = leftheader,  12, fontName, "times";
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic,  12, fontName, "times";
	fontset = leftfooter,  12, fontName, "times";
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "courier";
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; locked; preserveAspect; startGroup]
Markov Chains
:[font = input; locked; initialization; closed; preserveAspect]
*)
<<digraph.m
(*
:[font = section; inactive; preserveAspect; startGroup]
Input Transition Probability Matrix
:[font = text; inactive; locked; preserveAspect]
A Markov chain with stationary transition probability can be represented by a transition probability matrix. Each element(i,j) in the matrix is a constant, independent of time, and represents the one step transition probability from state i to state j.  
:[font = subsection; inactive; locked; preserveAspect; startGroup]
Example 1 -
:[font = text; inactive; preserveAspect]
Below is an example of a transition probability matrix with probabilities expressed in numerical values.
:[font = input; locked; initialization; preserveAspect; startGroup]
*)
transprobability = { { 0.15, 0.40, 0.45, 0.},
			         { 0.50, 0.,   0.50, 0.},
			         { 0.,   0.,   0.,   1.},
			         { 0.80, 0.,   0.20, 0.} };
MatrixForm [ transprobability ]

(*
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
MatrixForm[{{0.15, 0.4, 0.45, 0.}, {0.5, 0., 0.5, 0.}, 
 
   {0., 0., 0., 1.}, {0.8, 0., 0.2, 0.}}]
;[o]
0.15   0.4    0.45   0.

0.5    0.     0.5    0.

0.     0.     0.     1.

0.8    0.     0.2    0.
:[font = subsection; inactive; locked; initialization; preserveAspect; startGroup]
Example 2 -
:[font = text; inactive; locked; initialization; preserveAspect]
Below is an example of a transition probability matrix with probabilities expressed in symbolic expression.
:[font = input; locked; preserveAspect; startGroup]

transprobability = {{1-p0,p0},{p1,1-p1}};     
  
MatrixForm[transprobability]

:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
MatrixForm[{{1 - p0, p0}, {p1, 1 - p1}}]
;[o]
1 - p0   p0

p1       1 - p1
:[font = subsection; inactive; locked; preserveAspect; startGroup]
User Input
:[font = input; preserveAspect; startGroup]
ClearAll[r,p];
(*r = 1/2
p = 1/10*)
transprobability = { {(1-r)^2, 2 r (1-r), r^2}, {(1-r)p, (1-r)(1-p) + r p, r(1-p)},{p^2,2 p (1-p), (1-p)^2}};

MatrixForm [ transprobability ]

:[font = output; output; inactive; preserveAspect; endGroup; endGroup; endGroup]
MatrixForm[{{(1 - r)^2, 2*(1 - r)*r, r^2}, {p*(1 - r), (1 - p)*(1 - r) + p*r, (1 - p)*r}, {p^2, 2*(1 - p)*p, (1 - p)^2}}]
;[o]
       2                                         2
(1 - r)                 2 (1 - r) r             r


p (1 - r)               (1 - p) (1 - r) + p r   (1 - p) r

 2                                                     2
p                       2 (1 - p) p             (1 - p)
:[font = section; inactive; locked; preserveAspect; startGroup]
Visualization of the Markov chain
:[font = text; inactive; locked; preserveAspect]
The function computegraph will produce a graphic image of the Markov chain from the transition probability matrix.  An one step transition back to the same node in the Markov chain is represented by an inscribed circle at the node where the cycle is located. The Mathematica notebook interface seems to contain bugs in its graphical display functions.  The computegraph function might require multiple execution to generate the correct graphical output.
;[s]
2:0,0;357,1;453,-1;
2:1,0,0 ,times,0,12,0,0,0;1,0,0 ,times,1,12,0,0,0;
:[font = input; locked; initialization; preserveAspect; startGroup]
*)
computegraph [ transprobability ];

(*
:[font = postscript; PostScript; formatAsPostScript; output; inactive; preserveAspect; pictureLeft = 34; pictureWidth = 396; pictureHeight = 244.687; endGroup; endGroup]
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
%% Graphics
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.109773 0.350385 0.0583069 [
[(0.15)] .31444 .01472 0 0 Msboxa
[(0)] .37629 .12661 0 0 Msboxa
[(1)] .9213 .28468 0 0 Msboxa
[(0.4)] .70369 .23479 0 0 Msboxa
[(0)] .37629 .12661 0 0 Msboxa
[(2)] .62371 .57417 0 0 Msboxa
[(0.45)] .55489 .37954 0 0 Msboxa
[(1)] .9213 .28468 0 0 Msboxa
[(0)] .37629 .12661 0 0 Msboxa
[(0.5)] .59391 .17649 0 0 Msboxa
[(1)] .9213 .28468 0 0 Msboxa
[(2)] .62371 .57417 0 0 Msboxa
[(0.5)] .71762 .40027 0 0 Msboxa
[(2)] .62371 .57417 0 0 Msboxa
[(3)] .0787 .41609 0 0 Msboxa
[(1.)] .29631 .46598 0 0 Msboxa
[(3)] .0787 .41609 0 0 Msboxa
[(0)] .37629 .12661 0 0 Msboxa
[(0.8)] .28238 .3005 0 0 Msboxa
[(3)] .0787 .41609 0 0 Msboxa
[(2)] .62371 .57417 0 0 Msboxa
[(0.2)] .40609 .52428 0 0 Msboxa
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
[ ] 0 setdash
0 g
p
P
% Start of user PostScript
/mathtops {
gsave
MBeginOrig
moveto
MEndOrig
currentpoint
grestore
} bind def
/MAtocoords {
mathtops 4 2 roll mathtops
4 copy pop pop
3 -1 roll sub
/arry exch def
exch sub
/arrx exch def
arrx dup mul
arry dup mul
add sqrt
/arrl exch def
translate
} bind def
/MAarrowhead1 {
gsave
MAtocoords
[ arrx arrl div
arry arrl div
-1 arry mul arrl div
arrx arrl div
0 0 ]
concat
-0.05 0.0125 moveto 0 0 lineto -0.05 -0.0125 lineto fill
-0.05 0.0125 moveto 0 0 lineto -0.05 -0.0125 lineto
-0.05 0.0125 lineto stroke
grestore
} def
% End of user PostScript
p
p
.004 w
newpath
matrix currentmatrix
.04391 .02332 scale
8.56976 5.42861 1 0 365.73 arc
setmatrix
s
[(0.15)] .31444 .01472 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
6.85581 4.34288 1 0 365.73 arc
setmatrix
s
[(0)] .37629 .12661 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
16.7856 9.76489 1 0 365.73 arc
setmatrix
s
[(1)] .9213 .28468 0 0 Mshowa
p
.42447 .14058 m
.87313 .27071 L
s
% Start of user PostScript
-0.688091 -3.59835 3.39913 -1.36655 MAarrowhead1
% End of user PostScript
P
[(0.4)] .70369 .23479 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
6.85581 4.34288 1 0 365.73 arc
setmatrix
s
[(0)] .37629 .12661 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
11.3637 19.6948 1 0 365.73 arc
setmatrix
s
[(2)] .62371 .57417 0 0 Mshowa
p
.39176 .15458 m
.60824 .54619 L
s
% Start of user PostScript
-0.986064 -3.35823 0.986064 3.35823 MAarrowhead1
% End of user PostScript
P
[(0.45)] .55489 .37954 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
16.7856 9.76489 1 0 365.73 arc
setmatrix
s
[(1)] .9213 .28468 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
6.85581 4.34288 1 0 365.73 arc
setmatrix
s
[(0)] .37629 .12661 0 0 Mshowa
p
.87313 .27071 m
.42447 .14058 L
s
% Start of user PostScript
3.39913 -1.36655 -0.688091 -3.59835 MAarrowhead1
% End of user PostScript
P
[(0.5)] .59391 .17649 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
16.7856 9.76489 1 0 365.73 arc
setmatrix
s
[(1)] .9213 .28468 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
11.3637 19.6948 1 0 365.73 arc
setmatrix
s
[(2)] .62371 .57417 0 0 Mshowa
p
.895 .31026 m
.65001 .54858 L
s
% Start of user PostScript
3.59835 -0.688091 1.36655 3.39913 MAarrowhead1
% End of user PostScript
P
[(0.5)] .71762 .40027 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
11.3637 19.6948 1 0 365.73 arc
setmatrix
s
[(2)] .62371 .57417 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
1.43387 14.2724 1 0 365.73 arc
setmatrix
s
[(3)] .0787 .41609 0 0 Mshowa
p
.57553 .56019 m
.12687 .43006 L
s
% Start of user PostScript
0.688091 3.59835 -3.39913 1.36655 MAarrowhead1
% End of user PostScript
P
[(1.)] .29631 .46598 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
1.43387 14.2724 1 0 365.73 arc
setmatrix
s
[(3)] .0787 .41609 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
6.85581 4.34288 1 0 365.73 arc
setmatrix
s
[(0)] .37629 .12661 0 0 Mshowa
p
.105 .39051 m
.34999 .15219 L
s
% Start of user PostScript
-3.59835 0.688091 -1.36655 -3.39913 MAarrowhead1
% End of user PostScript
P
[(0.8)] .28238 .3005 0 0 Mshowa
P
p
.004 w
newpath
matrix currentmatrix
.05489 .02915 scale
1.43387 14.2724 1 0 365.73 arc
setmatrix
s
[(3)] .0787 .41609 0 0 Mshowa
newpath
matrix currentmatrix
.05489 .02915 scale
11.3637 19.6948 1 0 365.73 arc
setmatrix
s
[(2)] .62371 .57417 0 0 Mshowa
p
.12687 .43006 m
.57553 .56019 L
s
% Start of user PostScript
-3.39913 1.36655 0.688091 3.59835 MAarrowhead1
% End of user PostScript
P
[(0.2)] .40609 .52428 0 0 Mshowa
P
P
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd

:[font = section; inactive; locked; preserveAspect; startGroup]
Limiting Probabilities
:[font = text; inactive; locked; preserveAspect]
Calclimitingprobabilities computes the limiting probabilities for the Markov Chain.  The function assumes an irreducible, aperiodic and time homogenous Markov chain.  Then by Thereom 4.4.4 [Allen], the limiting probabilities always exist and are independent of the initial state probability distribution.  Thus the function computes the correct limiting probabilities for the input transition probability matrix.  The function outputs the results in column form with p0 at the top and pn at the bottom.

The following cell contains the Mathematica code for calclimitingprobability.  The cell is closed when the notebook is first opened.
:[font = input; initialization; closed; preserveAspect; startGroup]
*)
calclimitingprobability[transprobability_]:=
Block[{pimatrix, i, b, c},
	pimatrix = transprobability;
	Do [ pimatrix [[ i, i ]] = pimatrix [[ i, i ]] - 1, 
	{ i, 1, Length[pimatrix] } ];	
	pimatrix = Transpose [ pimatrix ];
	Do [ pimatrix [[ 1, i ]] = 1, { i, 1, Length[pimatrix] } ];

	b = Table[ 0, {i, 1, Length[transprobability]}];
	b [[ 1 ]] = 1;
	c = LinearSolve[pimatrix, b];
	c = MatrixForm[ Simplify [c] ];
	Print [ c ]
]
(*
:[font = message; inactive; preserveAspect; endGroup]
General::spell1: 
   Possible spelling error: new symbol name "pimatrix"
     is similar to existing symbol "pmatrix".
:[font = input; locked; initialization; preserveAspect; startGroup]
*)
calclimitingprobability [ transprobability ]
(*
:[font = print; inactive; preserveAspect; endGroup; endGroup]
0.330579

0.132231

0.268595

0.268595
:[font = section; inactive; preserveAspect; startGroup]
Probabilities of Recurrence(after n step transitions)
:[font = text; inactive; locked; preserveAspect]
calcnstep calculates the probabilities of ever returning to the same state within stp step. If the probability transition matrix is numerical, plotrecurrence plots the probabilities of returning to the same state as a function of steps up to twenty steps for each state.
:[font = input; initialization; closed; preserveAspect]
*)
calcrecurrence[transprobability_,n_,ii_]:= Module[ {idx1, k, temptp, s, size },

    size = Length [ transprobability ];
	temptp = transprobability;
	
	Do[ temptp[[idx1, ii]] = 0, 
	    {idx1, 1, size}
	  ];
	  
	s = Sum[ MatrixPower[temptp, k] . transprobability, 
	         {k, 0, n-1}
	       ];
	Return[Simplify[Chop[N[s[[ii,ii]]]]]];
]

calcnstep [ steps_, tp_ ] := Module [ {size},

  size = Length [ tp ];
  
  Do [ Print["f",Subscript[i-1],"= ",calcrecurrence[transprobability, steps, i]],
       {i,1,size} 
     ]
]
 		 
plotrecurrence [ tp_ ] := Module [ {size, invalidflag,i,j, state1, step1},

  invalidflag = 0;
  size = Length [ tp ];
  
  Do [ If [ NumberQ [ tp[[i,j]] ],
            {},
            invalidflag = 1
          ],
       {i,1,size}, {j,1,size}
     ];
     
  If [ invalidflag == 1,
       Print [ "plotrecurrence only computes on numerical Markov chains." ],
       {
         	Plot3D[calcrecurrence[tp,step1,state1],
         	       {step1,1,20}, {state1,1,size},
         	       PlotPoints -> { 20, size},
         	       ViewPoint -> {-2,-2,2},
	 	           AxesLabel->{"Steps","Node","Probability of Recurrence"},
	 	           DefaultFont ->{"Helvetica", 10}, Axes->True]
       }
     ]
]
 		  

(*
:[font = input; initialization; preserveAspect; startGroup]
*)
stp = 2;
calcnstep [ stp, transprobability ];
plotrecurrence [ transprobability ]
(*
:[font = print; inactive; preserveAspect; endGroup; endGroup]
f = 0.35
 0
f = 0.2
 1
f = 0.2
 2
f = 0.2
 3
:[font = section; inactive; locked; preserveAspect; startGroup]
Reducibility
:[font = text; inactive; locked; preserveAspect]
Calcreducibility attempts to determine if the Markov chain is irreducible.  It calculates up to two hundred steps to determine if a state is irreducible.
:[font = input; initialization; closed; preserveAspect]
*)
calcreducibility[transprobability_] := 
 
  Module [{counter, temptransprobability, maxcounter, invalidflag, size},

    invalidflag = 0;
    size = Length[transprobability];

	Do [ If [ NumberQ [ transprobability [[i,j]] ],
	          {},
	          invalidflag = 1
	        ],
	     {i,1,size}, {j,1,size}
	   ];
	   
	If [ invalidflag == 0,
	     {
	      Print["Original transition matrix: P",
	             Superscript["(1)"],"=", MatrixForm[transprobability]];
	             
	      counter = 1;
	      maxcounter = 200;
	      
	      temptransprobability = transprobability;
	      
	      While[ Min[temptransprobability] == 0 && counter < maxcounter,
	        {
	        temptransprobability = temptransprobability . transprobability; 
		    counter = counter + 1
		    }
		  ]	
		
	     If[ Min[temptransprobability] > 0,
	          { 
		      Print["This Markov chain is irreducible."];
			  Print["A transition can be made between any two states in ",
			         counter," steps."];
			  Print["The multi-step positive matrix: P",Superscript["("],
			      	Superscript[counter],Superscript[")"],"=",
			      	MatrixForm[temptransprobability]]
			  },
		      Print["There are states that cannot be reached with less than or equal to ",
	       	         maxcounter," steps."]
	       ]
	      },
	      {
	       Print [ "This function does not compute on symbolic transition probability" ];
	       Print [ "matrices." ];
	      }
	]
]
(*
:[font = input; locked; initialization; preserveAspect; startGroup]
*)
calcreducibility[transprobability];
(*
:[font = print; inactive; preserveAspect; endGroup; endGroup]
                             (1)
Original transition matrix: P   =0.15   0.4    0.45   0.

                                 0.5    0.     0.5    0.

                                 0.     0.     0.     1.

                                 0.8    0.     0.2    0.
This Markov chain is irreducible.
A transition can be made between any two states in 3 steps.
                                 (3)
The multi-step positive matrix: P   =
 
  0.423375   0.089      0.220125   0.2675

  0.51125    0.03       0.23375    0.225

  0.12       0.32       0.36       0.2

  0.338      0.048      0.254      0.36
:[font = section; inactive; locked; preserveAspect; startGroup]
Analyze Convergence Rate
:[font = text; inactive; locked; preserveAspect]
calcconvergencerate function returns the rate at which deviation from its limiting probability approaches zero. This rate tell us how rapidly the Markov chain "mixes". dd[i] is the deviation at time 0 for state i and nn is the current time.
:[font = input; locked; initialization; closed; preserveAspect]
*)
calcconvergencerate[localtransprobability_]:=

Block[{idx2, ss, dd, delta, nn, ff, size, invalidflag },

    size = Length[ localtransprobability ];
    invalidflag = 0;
        
    Do [ If [ NumberQ [ localtransprobability [[i,j]] ],
              invalidflag = 1,
              {}
            ],
            {i,1,size}, {j,1,size}
       ];
    
    If [ invalidflag == 0,
         {       
	       delta=Array[dd, size];
	       
	       ss[1] = - dd[1];
	       ss[idx2_] := ss[idx2 - 1] - dd[idx2];
	       
	       reduceonedelta = dd[ size ] -> ss[size-1];
	       
	       ff = delta . MatrixPower[localtransprobability, nn];
	       ff = ff /. reduceonedelta;
	       ff = MatrixForm[Simplify[ff]];
	       
	       Print[ff]
	     },
	     {
	       Print [ "This function only computes on symbolic transition probability"];
	       Print [ "matrices."]
	     }
	 ]
]
(*
:[font = input; initialization; preserveAspect; startGroup]
*)

calcconvergencerate[transprobability];
(*
:[font = print; inactive; preserveAspect; endGroup; endGroup; endGroup]
This function only computes on symbolic transition\
 
  probability
matrices.
^*)