(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "X Window System Mathematica Notebook Front End Version 2.2";

	X11StandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, fontName, "times";
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, fontName, "times";
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, fontName, "times";
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, fontName, "times";
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, fontName, "times";
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, fontName, "times";
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, fontName, "times";
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold,  12, fontName, "courier";
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, fontName, "courier";
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  12, fontName, "courier";
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l61, w356, h362.25,  12, fontName, "courier";
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535,  10, fontName, "times";
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  12, fontName, "times";
	fontset = leftheader,  12, fontName, "times";
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic,  12, fontName, "times";
	fontset = leftfooter,  12, fontName, "times";
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "courier";
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; locked; preserveAspect; startGroup]
Queuing Theory
:[font = input; locked; initialization; closed; preserveAspect]
*)
<<queue.m
(*
:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/1
:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/1 - Solution of Queue Parameters
:[font = text; inactive; preserveAspect]
To use the system, input the number of customers under rulen for probability of the desired number of customers in the system.  Rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, lambda and mu can be used to solve the queueing system. 
;[s]
2:0,0;55,1;324,-1;
2:1,0,0 ,times,0,12,0,0,0;1,0,0 ,times,1,12,0,0,0;
:[font = input; preserveAspect]
ClearAll[ a, k, p0, pk, lambdaa, lambda, mu, len, lens, lenq, ws, w, wq, n, pn];
ClearAll[mylist,pn, n];
rulen = n -> n; 
rule1 = rule1init -> len == 1;
rule2 = rule2init -> wq==1/20;
:[font = input; locked; preserveAspect; endGroup]

mylist=Sort[Flatten [Simplify [ Solve [{
	rule1init /. rule1,
	rule2init /. rule2,
	len == (lambda/mu)/(1-(lambda/mu)),
	lens == lambda/mu,
	lenq == (lambda/mu)^2/(1-(lambda/mu)),
	ws == 1/mu,
	w == 1/(mu*(1-(lambda/mu))),
	wq == w - ws
	},
	{lambda,mu,ws,w,wq, len,lens,lenq }, 
	{lambda,mu,ws,w,wq, len,lens,lenq } ]]]];
	Print[TableForm[mylist]];
pn = (1- mylist[[1,2]]/mylist[[5,2]])(mylist[[1,2]]/mylist[[5,2]])^n /. rulen;
Print["The probability of ", n /. rulen, " customer in the system pn: ", pn];
:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/1 - Visuallization
:[font = text; inactive; preserveAspect]
The function mm1lenplot will generate surface plots of L, Lq and Ls versus lambda and mu ranging from 0 to lambda-max and 0 to mu-max.  The function mm1waitplot generates surface plots of W, Wq and Wq.  The input values are the same for mm1waitplot.

mm1lenplot [ lambda-max, mu-max ]
mm1waitplot [ lambda-max, mu-max ]
:[font = input; preserveAspect; endGroup; endGroup]
mm1lenplot [ 20, 20 ];
mm1waitplot [ 20, 20 ];
:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/1/K
:[font = text; inactive; preserveAspect]
To use the system, input the limit of the number of customers under rulek and the number of customers under rulen for probability of the desired number of customers in the system.  Rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, lambda and mu can be used to solve the queueing system. 
:[font = subsection; inactive; preserveAspect; startGroup]
Example 1(lambda and mu are not equal.)
:[font = input; preserveAspect; endGroup]
ClearAll[ a, k, p0, pk, lambdaa, lambda, mu, len, lens, lenq, ws, w, wq, n, pn];
rulek = k -> 26;
rulen = n -> n; 
rule1 = rule1init -> a == 0.88;
rule2 = rule2init -> lambda == 4.;
:[font = subsection; inactive; preserveAspect; startGroup]
Example 2(lambda and mu are equal.)
:[font = input; preserveAspect; endGroup]
ClearAll[ a, k, p0, pk, lambdaa, lambda, mu, len, lens, lenq, ws, w, wq, n, pn];
rulek = k -> 26;
rulen = n -> n; 
rule1 = rule1init -> mu == 4;
rule2 = rule2init -> lambda == 4.;
:[font = subsection; inactive; locked; preserveAspect; startGroup]
Formulas
:[font = input; locked; preserveAspect; endGroup]
mylist = Sort[Flatten[Simplify[Solve[{
	rule1init /. rule1,
	rule2init /. rule2,
	a == lambda/mu,
	p0 == 1 / ( k + 1 ) /. rulek,
	lambdaa == ( 1 - p0 ) lambda,
	len == k/2 /. rulek,
	lens == len - lenq,
	lenq == len - ( 1 - p0 ),
	ws == 1/mu,
	w == len / lambdaa,
	wq == lenq / lambdaa
	},
	{lambda,a,mu,ws,w,wq, len,lens,lenq, lambdaa, p0 }, 
	{lambda,a,mu,rho,ws,w,wq, len,lens,lenq, lambdaa, p0  }]]]];


If[mylist[[2,2]] == mylist[[7,2]],
	{
		Print[TableForm[mylist]];
		pn = 1/(k + 1) /. rulek;
	},
	{     
		mylist = Sort[Flatten[Simplify[Solve[{
		 	rule1init /. rule1,
			rule2init /. rule2,
		 	a == lambda / mu,
		 	pk == ( 1-a ) a^k / ( 1- a^(k+1) ) /. rulek,
	     	p0 == ( 1 - a ) / ( 1 - a^(k+1) ) /. rulek,
	 	 	lambdaa == ( 1 - pk ) lambda /. rulek,
		 	len == a ( 1 - ( k+1 ) a^k + k a^(k+1)) / ( ( 1 - a ) ( 1 - a^(k+1) ) ) /. rulek,
		 	lens == len - lenq,
		 	lenq == len - ( 1 - p0 ),
	     	ws == 1/mu,
	     	w == len / lambdaa,
	     	wq == lenq / lambdaa
	     	},
	     	{lambdaa,mu,a,ws,w,wq, len,lens,lenq, lambda, p0, pk}, 
	     	{lambdaa,mu,a,ws,w,wq, len,lens,lenq, lambda, p0, pk}]]]];
	     	Print[TableForm[mylist]];
	     	pn = (1 - mylist[[1,2]]) (mylist[[1,2]])^(n /. rulen)  /(1 - (mylist[[1,2]])^(k + 1)) /. rulek ;
	}
  ];
Print["The probability of ", n /. rulen, " customer in the system is pn: ", pn];
:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/1/K - Visualization
:[font = text; inactive; preserveAspect]
The function mm1klenplot generates surface plots of L and Lq versus lambda and mu ranging from 0 to lambda-max and 0 to mu-max for the M/M/1/K queueing sysem given a value of k.  The function mm1kwaitplot is similar, however it computes the plots for W and Wq.

mm1klenplot [ lambda-max, mu-max, k ]
mm1kwaitplot [ lambda-max, mu-max, k ]

:[font = input; preserveAspect; endGroup; endGroup]
mm1klenplot[ 20,20,5 ];
mm1kwaitplot [ 20,20,5 ];
:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/c
:[font = text; inactive; preserveAspect]
The following function returns the probability of n customer in the system where j is the number of customer, c is the number of server, a is the traffic intensity, and pp0 is the probability of 0 customer in the system.
:[font = input; locked; initialization; closed; preserveAspect]
*)
mmcp[j_, c_, a_, pp0_] := Module[{},
	If[!NumberQ[j], 
	    Return[{pp0 a^j /j!, pp0 a^j/c!/c^(j-c)}], 
		If[i <= c,  
			Return[{pp0 a^j /j! }], 
			Return[{pp0 a^j/c!/c^(j-c)}]
		  ]
	  ];
]

(*
:[font = text; inactive; preserveAspect]
To use the system, input the number of severs available under rulec and the number of customers under rulen for probability of the desired number of customers in the system.  When a symbolic expression is given to n, the probability of n customers in the system is a list The first element is for n <= c and the second one is for n>=c. rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, lambda and mu can be used to solve the queueing system. 
:[font = input; preserveAspect]
ClearAll[rulec,rulen,p0,pn,mylist,lambda,mu]
ClearAll[ a, c, lambdaa, lambda,mu,len,lens,lenq,ws,w,wq,n,c,i];
rulec = c -> 3; 
rulen = n -> n; 
rule1 = rule1init -> a == 1/2;
rule2 = rule2init -> mu == 20;
:[font = input; preserveAspect]

mylist = Sort [ Flatten [ Simplify [ Solve [ {
	rule1init /. rule1,
	rule2init /. rule2,
    a == lambda/mu,
	lenq == a cca[c,a] / ( c - a ) /. rulec,
	len == lambda w,
	lens ==len - lenq,
	ws == 1/mu,
	wq == lenq / lambda,
	w == wq + ws
	},
	{ a, lambda, mu, lenq, len, lens, w, ws, wq },
	{ a, lambda, mu, lenq, len, lens, w, ws, wq } ] ] ] ];
Print[TableForm[mylist]];
p0 = Simplify[1 /(mylist[[1,2]]^c/c!/(1-mylist[[1,2]]/c)+Sum[(mylist[[1,2]]^i)/(i!),{i,0,c-1}]) /. rulec];
Trace[pn = Simplify[mmcp[n /. rulen, c /. rulec, mylist[[1,2]], p0]]];
Print["The probability of 0 customer in the system p0: ", p0];
Print["The probability of ", n /. rulen, " customer in the system pn: ", pn];
Print[""];
Print["Note: pn is a list. The first element is the probability of n customer in the node"];
Print["when n is less than or equal to the number of server and second element is the"];
Print["probability of n customer in the node when n is greater than or equal to the number"];
Print["of server."];	

:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/c - Visualization
:[font = text; inactive; preserveAspect]
The function mmclenplot generates plots of L and Lq versus the number of servers and rho ranging from 0 to servers-max and 0 to 1 for rho.  The input value gives the maximum number of servers.  Function mmcwaitplot generates a surface plot of W and Wq.  Input is the same as mmclenplot.  The function ccaplot generates a surface plot of Erlang's Delay Formula (C[c,a]), where a runs from 0 to 1 and c is the maximum number of servers input.

mmclenplt [ servers-max ] 
mmcwaitplt [ servers-max ] 
ccaplot [ servers-max ] 
:[font = input; preserveAspect; endGroup; endGroup]
mmclenplot[ 10 ];
mmcwaitplot [ 10 ];
ccaplot [ 5 ];
:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/c/c - M/M/c loss system
:[font = input; initialization; preserveAspect]
*)
ClearAll[p]
mmccp[n_, c_, a_] := Module[{},Return[Simplify[((a^n)/n!)/Sum[ a^i / i!, {i,0,c}]]]]
(*
:[font = text; inactive; locked; preserveAspect]
To use the system, input the number of severs available under rulec and the number of server under rulen for the probability of the desired number of server that are busy. rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, lambda and mu can be used to solve the queueing system. 
:[font = input; preserveAspect]
ClearAll[ a, c, lambdaa, lambda,mu,len,lens,lenq,ws,w,wq,n,c,mylist];

rulec = c -> 2;
rulen = n -> n;
rule1 = rule1init -> lambda == 10;
rule2 = rule2init -> mu == 20;
:[font = input; locked; preserveAspect]
mylist = Sort[Flatten[Simplify[Solve[{
			rule1init /. rule1,
			rule2init /. rule2,
			a == lambda / mu,
			lambdaa == lambda ( 1 - bca[ c, a ] ) /. rulec,
			len == a ( 1 - bca[ c, a ] ) /. rulec,
			lens == len,
			lenq == 0,
			wq == 0,
			ws == w,
			w == len / lambdaa
		  	},
	     {lambdaa,mu,a,ws,w,wq, len,lens,lenq, lambda }, 
	     {lambdaa,mu,a,ws,w,wq, len,lens,lenq, lambda }]]]];
Print[TableForm[mylist]];
Print["The probability of ", n /. rulen, " customer in the system is ", mmccp[n /. rulen,c /. rulec ,mylist[[1,2]]]];
Print["Note: n=0,...,",c /. rulec];
Print["The probability of all servers are busy is ",bca[c /. rulec, mylist[[1,2]]]];

:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/c/c - Visualization
:[font = text; inactive; preserveAspect]
The function mmcclenplot generates a plot of the total number in the system versus the numbers of servers and rho ranging from 0 to servers-max and 0 to 1 for rho.  The input is the maximum number of servers.  Since there is no queuing allowed, by definition Wq=0 and Lq=0.  Thus L=Ls and W=Ws=1\mu.  The plot for W can be seen in the M/M/1 queueing section and is not presented here.  The function bcaplot generates a plot of Erlang's Loss Formula B[c,a] for a=0 to 1 and c the maximum number of servers.

mmcclenplt [ servers-max ] : ( a=0->1)
bcaplot [ servers-max ] : ( a=0->1 )
:[font = input; preserveAspect; endGroup; endGroup]
mmcclenplot [ 10 ];
bcaplot [ 5 ];

:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/Infinity
:[font = text; inactive; locked; preserveAspect]
To use the system, input the number of customers under rulen for probability of the desired number of customers in the system. rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, lambda and mu can be used to solve the queueing system. 
:[font = input; preserveAspect]
ClearAll[mylist,pn, n];
rulen = n -> n; 
rule1 = rule1init -> lambda == 5;
rule2 = rule2init -> mu == 6;
:[font = input; locked; preserveAspect]
mylist=Sort[Flatten [Simplify [ Solve [{
	rule1init /. rule1,
	rule2init /. rule2,
	a == lambda / mu,
 	len == a,
	lens == len,
	lenq == 0,
	ws == w,
	w == len /lambda,
	wq == 0
	},
	{a,lambda,mu,ws,w,wq, len,lens,lenq }, 
	{a,lambda,mu,ws,w,wq, len,lens,lenq } ]]]];
	Print[TableForm[mylist]];
pn = ((mylist[[1,2]])^n / n! /. rulen)Exp[-mylist[[1,2]]];
Print["The probability of ", n /. rulen, " customer in the system pn: ", pn];

:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/Infinity
:[font = text; inactive; locked; preserveAspect; endGroup; endGroup]
The plots for the M/M/Infinity system are not shown.  Since by definition, Wq=0 and Lq=0, W=Ws and L=lambda/mu.  The plot for W=Ws can be seen in the M/M/1 section.  
:[font = section; inactive; locked; preserveAspect; startGroup]
M/M/1/K/K - Machine Repair with One Repairman
:[font = input; locked; initialization; closed; preserveAspect]
*)
mm1kkp[n_, p0_, z_, k_] := Module[{}, Return[((k!)/((k-n)!)) z^(-n) p0]]
(*
:[font = text; inactive; locked; preserveAspect]
To use the system, input the number of machine available under rulek and the number of machines that are out of service under rulen for probability of the desired number of the machines that are out of service. rule1 and rule2 are reserved for the given(known) values of the queueing system. At least two independent values are expected. For example, Mean Time To Failure and Ws can be used to solve the queueing system. 
:[font = input; preserveAspect]
ClearAll[ a, c, rulek, rulen, lambdaa, lambda,alpha,mu,len,lens,lenq,ws,w,wq, rho, MTTF, p0, z, mylist]
rulek = k -> 2;
rulen = n -> n;
rule1 = rule1init -> MTTF == 20;
rule2 = rule2init -> ws == 10;
:[font = input; locked; preserveAspect]

mylist = Sort[Flatten[Simplify[Solve[{
		rule1init /. rule1,
		rule2init /. rule2,
		MTTF == 1 / alpha,
		p0 == bca [ k, z ] /. rulek,
		z == MTTF / ws,
		rho == 1 - p0,
		lambda == rho / ws,
		w == k / lambda - MTTF /. rulek,
		ws == 1 / mu,
		wq == w - ws,
		len == lambda w,
		lenq == lambda wq
		},
		{ alpha, p0, z, MTTF, rho, lambda, mu, w, ws, wq, len, lenq },
		{ alpha, p0, z, MTTF, rho, lambda, mu, w, ws, wq, len, lenq }]]]];
Print[TableForm[mylist]];		
Print["The probability of ", n /. rulen," machines are out of services is ",mm1kkp[n /. rulen, mylist[[7,2]], mylist[[12,2]], k /. rulek]];
Print["Note: n=0,...,",k /. rulek];
Print["The probability that the system is available is ", 1 - mm1kkp[k /. rulek, mylist[[7,2]], mylist[[12,2]], k /. rulek]];
:[font = subsection; inactive; locked; preserveAspect; startGroup]
M/M/1/K/K - Visualization
:[font = text; inactive; preserveAspect]
The function mm1kklenplot generates a surface plot for L versus lambda and number of customers k ranging from 0 to lambda-max and 0 to k-max at a mean time to failure MTTF.  The function mm1kkwaitplot generates a surface plot of W and Wq of 0 to lambda-max, 1 to k-max for given mu and mean time to failure, (MTTF).

mm1kklenplot [ lambda-max, k-max, MTTF ]  - Note L is independent of mu
mm1kkwaitplot [ lambda-max, mu, k-max, MTTF ] 
:[font = input; preserveAspect; endGroup; endGroup; endGroup]
mm1kklenplot [ 10,5,0.7];
mm1kkwaitplot [ 5,10,6,0.88 ];

^*)